package dk.nsp.backgroundjob.ws;

import dk.nsp.backgroundjob.service.StackedOperationsService;
import org.apache.log4j.Logger;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

public abstract class AbstractOperationsServlet extends AbstractServlet {
    private static final Logger log = Logger.getLogger(AbstractOperationsServlet.class);

    @Override
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
        log.trace("Starting " + getServletName());
        int status = 200;
        String body = "OK";

        try {
            getOperationsService().run();
        } catch (Exception e) {
            log.error("Error running " + getServletName(), e);
            status = 500;
            body = "Internal Error";
        }

        response.setStatus(status);
        response.getOutputStream().println(body);
        response.getOutputStream().flush();
    }

    protected abstract StackedOperationsService getOperationsService();
}
