package dk.nsp.backgroundjob.ws;

import dk.nsp.backgroundjob.service.StackedOperationsService;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mockito;
import org.springframework.mock.web.MockHttpServletRequest;
import org.springframework.mock.web.MockHttpServletResponse;

import static org.junit.Assert.assertEquals;

public class AbstractOperationsStatusServletTest {

    private StackedOperationsService operationsService;
    private AbstractOperationsStatusServlet abstractOperationsStatusServlet;

    @Before
    public void setUp() {
        operationsService = Mockito.mock(StackedOperationsService.class);
        abstractOperationsStatusServlet = new AbstractOperationsStatusServlet() {
            @Override
            protected StackedOperationsService getOperationsService() {
                return operationsService;
            }
        };
    }

    @Test
    public void doGet_WhenLatestRunSucceeded_Returns200() {
        MockHttpServletRequest request = new MockHttpServletRequest();
        MockHttpServletResponse response = new MockHttpServletResponse();
        Mockito.when(operationsService.latestRunSuccessful()).thenReturn(true);

        abstractOperationsStatusServlet.doGet(request, response);

        assertEquals(200, response.getStatus());
    }

    @Test
    public void doGet_WhenLatestRunFailed_Returns500() {
        MockHttpServletRequest request = new MockHttpServletRequest();
        MockHttpServletResponse response = new MockHttpServletResponse();
        Mockito.when(operationsService.latestRunSuccessful()).thenReturn(false);

        abstractOperationsStatusServlet.doGet(request, response);

        assertEquals(500, response.getStatus());
    }
}