package dk.nsp.xdscleanup.common.model;

import dk.nsp.xdscleanup.common.model.xds.ReferenceType;
import dk.nsp.xdscleanup.common.model.xds.AssociationType;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

public class Association extends RegistryObject {
    private AssociationType associationType;
    private String sourceUuid;
    private ReferenceType sourceType;
    private String targetUuid;
    private ReferenceType targetType;

    public Association(long entryId, String entryUuid, AssociationType associationType, String sourceUuid, ReferenceType sourceType, String targetUuid, ReferenceType targetType) {
        super(entryId, entryUuid);
        this.associationType = associationType;
        this.sourceUuid = sourceUuid;
        this.sourceType = sourceType;
        this.targetUuid = targetUuid;
        this.targetType = targetType;
    }

    public AssociationType getAssociationType() {
        return associationType;
    }

    public String getSourceUuid() {
        return sourceUuid;
    }

    public ReferenceType getSourceType() {
        return sourceType;
    }

    public String getTargetUuid() {
        return targetUuid;
    }

    public ReferenceType getTargetType() {
        return targetType;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.SHORT_PREFIX_STYLE)
                .append("associationType", associationType)
                .append("sourceUuid", sourceUuid)
                .append("sourceType", sourceType)
                .append("targetUuid", targetUuid)
                .append("targetType", targetType)
                .toString();
    }
}
