package dk.nsp.xdscleanup.common.model;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.util.Objects;

/**
 * Represents an object that will be deleted. Can be a DocumentEntry, Association, SubmissionSet and (tentatively) Folder
 */
public abstract class RegistryObject {
    private long entryId;
    private String entryUuid;

    public RegistryObject(long entryId, String entryUuid) {
        this.entryId = entryId;
        this.entryUuid = entryUuid;
    }

    public long getEntryId() {
        return entryId;
    }

    public void setEntryId(long entryId) {
        this.entryId = entryId;
    }

    public String getEntryUuid() {
        return entryUuid;
    }

    public void setEntryUuid(String entryUuid) {
        this.entryUuid = entryUuid;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.SHORT_PREFIX_STYLE)
                .append("entryId", entryId)
                .append("entryUuid", entryUuid)
                .toString();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        RegistryObject that = (RegistryObject) o;
        return entryId == that.entryId && Objects.equals(entryUuid, that.entryUuid);
    }

    @Override
    public int hashCode() {
        return Objects.hash(entryId, entryUuid);
    }
}
