package dk.nsp.xdscleanup.common.util;

import java.time.*;
import java.time.format.DateTimeFormatter;

public class DateTimeUtils {
    public static String format(Instant pointInTime) {
        if(pointInTime == null) {
            return null;
        }

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss.SSSSSS");
        return formatter.format(LocalDateTime.ofInstant(pointInTime, ZoneOffset.UTC));
    }

    public static ZonedDateTime subtractMonths(ZonedDateTime pointInTime, int months) {
        return pointInTime.minus(Period.ofMonths(months));
    }

    public static long minutesBetween(ZonedDateTime firstPointInTime, ZonedDateTime secondfirstPointInTime) {
        Duration duration = Duration.between(firstPointInTime, secondfirstPointInTime);
        return duration.getSeconds() / 60;
    }
}
