package dk.nsp.xdscleanup.deprecated.model;

import dk.nsp.xdscleanup.common.model.xds.TypeCode;

public class DocumentTypeDeprecatedCleanup {

    private final TypeCode typeCode;

    public DocumentTypeDeprecatedCleanup(TypeCode typeCode) {
        this.typeCode = typeCode;
    }

    public TypeCode getTypeCode() {
        return typeCode;
    }

    public static DocumentTypeDeprecatedCleanup parse(String spec) {
        if(spec == null) {
            indicateInvalidSpec(spec);
        }

        String[] parts = spec.split("#");
        if(parts.length != 2) {
            indicateInvalidSpec(spec);
        }

        String codeName = parts[0];
        String codeScheme = parts[1];

        return new DocumentTypeDeprecatedCleanup(new TypeCode(codeName, codeScheme));
    }

    private static void indicateInvalidSpec(String spec) {
        throw new IllegalArgumentException(String.format("Not a valid DocumentTypeDeprecatedCleanup: %s! Proper format is: <code-name>#<code-scheme>", spec));
    }

}
