package dk.nsp.xdscleanup.deprecated.setup;

import dk.nsp.xdscleanup.nxrg.dao.NxrgDao;
import dk.nsp.xdscleanup.nxrg.dao.impl.NxrgDaoImpl;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;
import org.springframework.jdbc.datasource.lookup.JndiDataSourceLookup;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import javax.sql.DataSource;

@Configuration
@EnableTransactionManagement
public class DBSetup {

    @Value("${datasource.nxrg.jndi.name}")
    private String nxrgJndiName;

    @Value("${deletion.max.attempts}")
    private int deletionMaxAttempts;

    @Value("${deletion.in.clause.max.size}")
    private int inClauseMaxSize;

    // Nxrg

    @Bean
    public DataSource nxrgDataSource() {
        return new JndiDataSourceLookup().getDataSource(nxrgJndiName);
    }

    @Bean(name="tx-nxrg")
    public PlatformTransactionManager nxrgTransactionManager(DataSource nxrgDataSource) {
        return new DataSourceTransactionManager(nxrgDataSource);
    }

    @Bean
    public NxrgDao nxrgDao(DataSource nxrgDataSource) {
        return new NxrgDaoImpl(nxrgDataSource, deletionMaxAttempts, inClauseMaxSize);
    }
}
