package dk.nsp.xdscleanup.deprecated.model;

import org.junit.Test;

import static org.junit.Assert.assertEquals;

public class DocumentTypeDeprecatedCleanupTest {

    @Test(expected = IllegalArgumentException.class)
    public void parse_tooFewComponents_throwsException() {
        // Arrange
        String spec = "";

        // Act
        DocumentTypeDeprecatedCleanup result = DocumentTypeDeprecatedCleanup.parse(spec);

        // Assert
    }

    @Test(expected = IllegalArgumentException.class)
    public void parse_tooManyComponents_throwsException() {
        // Arrange
        String spec = "lots#of#random#stuff#in#here";

        // Act
        DocumentTypeDeprecatedCleanup result = DocumentTypeDeprecatedCleanup.parse(spec);

        // Assert
    }

    @Test(expected = IllegalArgumentException.class)
    public void parse_emptyValues_throwsException() {
        // Arrange
        String spec = "#";

        // Act
        DocumentTypeDeprecatedCleanup result = DocumentTypeDeprecatedCleanup.parse(spec);

        // Assert
    }

    @Test(expected = IllegalArgumentException.class)
    public void parse_noHash_throwsException() {
        // Arrange
        String spec = "bla";

        // Act
        DocumentTypeDeprecatedCleanup result = DocumentTypeDeprecatedCleanup.parse(spec);

        // Assert
    }

    @Test
    public void parse_wellformedSpecification_success() {
        // Arrange
        String spec = "39289-4#2.16.840.1.113883.6.1";

        // Act
        DocumentTypeDeprecatedCleanup result = DocumentTypeDeprecatedCleanup.parse(spec);

        // Assert
        assertEquals("39289-4", result.getTypeCode().getCodeName());
        assertEquals("2.16.840.1.113883.6.1", result.getTypeCode().getCodeScheme());

    }

}
