package dk.nsp.xdscleanup.deprecated.stack.registry.deprecated;

import dk.nsp.backgroundjob.stack.StackOperation;
import dk.nsp.xdscleanup.common.model.xds.TypeCode;
import dk.nsp.xdscleanup.deprecated.factory.CleanupOperationsFactory;
import dk.nsp.xdscleanup.deprecated.model.DocumentTypeDeprecatedCleanup;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mockito;

import java.util.Arrays;
import java.util.List;

import static org.junit.Assert.assertEquals;

public class DeprecatedDocumentCleanupSupplierTest {
    private CleanupOperationsFactory cleanupOperationsFactory;
    private DeprecatedDocumentCleanupSupplier deprecatedDocumentCleanupSupplier;

    @Before
    public void setUp() {
        cleanupOperationsFactory = Mockito.mock(CleanupOperationsFactory.class);
        deprecatedDocumentCleanupSupplier = new DeprecatedDocumentCleanupSupplier(cleanupOperationsFactory,
                Arrays.asList(new DocumentTypeDeprecatedCleanup( new TypeCode("abc", "1.1.1.1")),new DocumentTypeDeprecatedCleanup( new TypeCode("def", "1.1.1.1"))));
    }

    @Test
    public void run_Returns372ExpectedSuppliers() {
        List<StackOperation> stackOperations = deprecatedDocumentCleanupSupplier.run();

        assertEquals(372*2, stackOperations.size());
    }
}