package dk.nsp.xdscleanup.stack.registry.status90;

import dk.nsp.backgroundjob.stack.StackOperation;
import dk.nsp.xdscleanup.factory.CleanupOperationsFactory;
import org.apache.commons.lang3.StringUtils;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class Status90RegistryCleanupSupplier implements StackOperation {
    private final CleanupOperationsFactory cleanupOperationsFactory;
    private static final List<String> PREFIX = IntStream.range(0, 100).boxed().collect(Collectors.toList()).stream().map(prefix -> patientIdPrefix(prefix)).collect(Collectors.toList());

    public Status90RegistryCleanupSupplier(CleanupOperationsFactory cleanupOperationsFactory) {
        this.cleanupOperationsFactory = cleanupOperationsFactory;
    }

    @Override
    public List<StackOperation> run() {
        return PREFIX.stream().map(cleanupOperationsFactory::createStatus90RegistryPatientIdPrefixCleanupSupplier)
                .collect(Collectors.toList());
    }

    private static String patientIdPrefix(int prefix) {
        return StringUtils.leftPad(prefix + "", 2, "0");
    }
}
