package dk.nsp.xdscleanup.model;

import org.junit.Test;

import static org.junit.Assert.assertEquals;

public class DocumentTypeCleanupSpecificationTest {
    @Test(expected = IllegalArgumentException.class)
    public void parse_tooFewComponents_throwsException() {
        // Arrange
        String spec = "";

        // Act
        DocumentTypeCleanupSpecification result = DocumentTypeCleanupSpecification.parse(spec);

        // Assert
    }

    @Test(expected = IllegalArgumentException.class)
    public void parse_tooManyComponents_throwsException() {
        // Arrange
        String spec = "lots#of#random#stuff#in#here";

        // Act
        DocumentTypeCleanupSpecification result = DocumentTypeCleanupSpecification.parse(spec);

        // Assert
    }

    @Test(expected = IllegalArgumentException.class)
    public void parse_malformedNumberOfMonths_throwsException() {
        // Arrange
        String spec = "37.47#1-2-3#-1";

        // Act
        DocumentTypeCleanupSpecification result = DocumentTypeCleanupSpecification.parse(spec);

        // Assert
    }

    @Test
    public void parse_wellformedSpecification_success() {
        // Arrange
        String spec = "39289-4#2.16.840.1.113883.6.1#2";

        // Act
        DocumentTypeCleanupSpecification result = DocumentTypeCleanupSpecification.parse(spec);

        // Assert
        assertEquals("39289-4", result.getTypeCode().getCodeName());
        assertEquals("2.16.840.1.113883.6.1", result.getTypeCode().getCodeScheme());
        assertEquals( 2, result.getNumberOfMonthsToKeep());
    }
}