package dk.nsp.xdscleanup.stack.registry.status90;

import dk.nsp.backgroundjob.stack.StackOperation;
import dk.nsp.xdscleanup.factory.CleanupOperationsFactory;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mockito;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

public class Status90RegistryCleanupSupplierTest {

    private CleanupOperationsFactory cleanupOperationsFactory;
    private Status90RegistryCleanupSupplier status90RegistryCleanupSupplier;

    @Before
    public void setUp() {
        cleanupOperationsFactory = Mockito.mock(CleanupOperationsFactory.class);
        status90RegistryCleanupSupplier = new Status90RegistryCleanupSupplier(cleanupOperationsFactory);
    }

    @Test
    public void run_Returns10ExpectedSuppliers() {


        List<Status90RegistryPatientIdPrefixCleanupSupplier> prefixSuppliers = new ArrayList<>();
        for (int i = 0; i < 100; i++) {
            prefixSuppliers.add(Mockito.mock(Status90RegistryPatientIdPrefixCleanupSupplier.class));
        }

        Mockito.when(cleanupOperationsFactory.createStatus90RegistryPatientIdPrefixCleanupSupplier(Mockito.anyString()))
                .thenReturn(prefixSuppliers.get(0))
                .thenReturn(prefixSuppliers.get(1))
                .thenReturn(prefixSuppliers.get(2))
                .thenReturn(prefixSuppliers.get(3))
                .thenReturn(prefixSuppliers.get(4))
                .thenReturn(prefixSuppliers.get(95))
                .thenReturn(prefixSuppliers.get(96))
                .thenReturn(prefixSuppliers.get(97))
                .thenReturn(prefixSuppliers.get(98))
                .thenReturn(prefixSuppliers.get(99));

        List<StackOperation> stackOperations = status90RegistryCleanupSupplier.run();
        assertEquals(100, stackOperations.size());

        Mockito.verify(cleanupOperationsFactory).createStatus90RegistryPatientIdPrefixCleanupSupplier("00");
        Mockito.verify(cleanupOperationsFactory).createStatus90RegistryPatientIdPrefixCleanupSupplier("01");
        Mockito.verify(cleanupOperationsFactory).createStatus90RegistryPatientIdPrefixCleanupSupplier("02");
        Mockito.verify(cleanupOperationsFactory).createStatus90RegistryPatientIdPrefixCleanupSupplier("03");
        Mockito.verify(cleanupOperationsFactory).createStatus90RegistryPatientIdPrefixCleanupSupplier("04");
        Mockito.verify(cleanupOperationsFactory).createStatus90RegistryPatientIdPrefixCleanupSupplier("95");
        Mockito.verify(cleanupOperationsFactory).createStatus90RegistryPatientIdPrefixCleanupSupplier("96");
        Mockito.verify(cleanupOperationsFactory).createStatus90RegistryPatientIdPrefixCleanupSupplier("97");
        Mockito.verify(cleanupOperationsFactory).createStatus90RegistryPatientIdPrefixCleanupSupplier("98");
        Mockito.verify(cleanupOperationsFactory).createStatus90RegistryPatientIdPrefixCleanupSupplier("99");
    }
}