
-- scriptene er kopieret fra nxrg komponenten script for script.
-- herefter er strengen
--          engine = InnoDB collate 'utf8_bin';
-- fjernet.
-- Da et enkelt scritp skulle justers pga h2 database ligger dette i selvstændigt script.
-- og resterende scripts fra nxrg i efterfølgende fil.

--
-- Table and index structure for table `submissionsets`
--
create table if not exists `submissionsetcontent` (
  `id` int(11) not null auto_increment,
  `xml` longtext,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,
  constraint submissionsetcontent_pk primary key (id)
);

create table if not exists `submissionsets` (
  `id` int(11) not null auto_increment,
  `entryuuid` varchar(64) not null,
  `patientid` varchar(32) not null,
  `patientid_assigningauthorityid` varchar(32) not null,
  `patientid_assigningauthoritytype` varchar(16) not null,
  `uniqueid` varchar(64) not null,
  `migration_uniqueid_fix` int(11) not null default 0,
  `submissionsetcontentid` int(11) not null unique,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,
  constraint submissionset_pk primary key (id),
  constraint submissionset_entryuuid_uk unique key (entryuuid),
  constraint submissionset_uniqueid_uk unique key (uniqueid, migration_uniqueid_fix),
  constraint submissionset_fk_content foreign key (submissionsetcontentid) references submissionsetcontent(id) on delete cascade
);

--
-- Table and index structure for table `documententries`
--
create table if not exists `documententrycontent` (
  `id` int(11) not null auto_increment,
  `xml` longtext,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,
  constraint documententrycontent_pk primary key (id)
);

create table if not exists `documententries` (
  `id` int(11) not null auto_increment,
  `entryuuid` varchar(64) not null,
  `logicaluuid` varchar(64) not null,
  `version` int(11) not null,
  `patientid` varchar(32) not null,
  `patientid_assigningauthorityid` varchar(32) not null,
  `patientid_assigningauthoritytype` varchar(16) not null,
  `availabilitystatus` varchar(64) not null,
  `documententrytype` varchar(64) not null,
  `uniqueid` varchar(64) not null,
  `classcode_codename` varchar(64) not null,
  `classcode_schemename` varchar(64) not null,
  `typecode_codename` varchar(64) not null,
  `typecode_schemename` varchar(64) not null,
  `practicesettingcode_codename` varchar(64) not null,
  `practicesettingcode_schemename` varchar(64) not null,
  `creationtime` datetime(6),
  `servicestarttime` datetime(6),
  `servicestoptime` datetime(6),
  `healthcarefacilitytypecode_codename` varchar(64) not null,
  `healthcarefacilitytypecode_schemename` varchar(64) not null,
  `formatcode_codename` varchar(64) not null,
  `formatcode_schemename` varchar(64) not null,
  `documententrycontentid` int(11) not null unique,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,
  `migration_pid` int(11) not null default 0,
  constraint documententry_pk primary key (id),
  constraint documententry_entryuuid_uk unique key (entryuuid),
  constraint documententry_fk_content foreign key (documententrycontentid) references documententrycontent(id) on delete cascade
);

--
-- Table and index structure for table `folders`
--
create table if not exists `foldercontent` (
  `id` int(11) not null auto_increment,
  `xml` longtext,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,
  constraint foldercontent_pk primary key (id)
);

create table if not exists `folders` (
  `id` int(11) not null auto_increment,
  `entryuuid` varchar(64) not null unique,
  `logicaluuid` varchar(64) not null,
  `version` int(11) not null,
  `patientid` varchar(32) not null,
  `patientid_assigningauthorityid` varchar(32) not null,
  `patientid_assigningauthoritytype` varchar(16) not null,
  `availabilitystatus` varchar(64) not null,
  `uniqueid` varchar(64) not null,
  `lastupdatetime` datetime(6) not null,
  `foldercontentid` int(11) not null unique,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,

  constraint folder_pk primary key (id),

  constraint folder_fk_content foreign key (foldercontentid) references foldercontent(id) on delete cascade
);

--
-- Table and index structure for table `associations`
--
create table if not exists `associationcontent` (
  `id` int(11) not null auto_increment,
  `xml` longtext,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,
  constraint associationcontent_pk primary key (id)
);

create table if not exists `associations` (
  `id` int(11) not null auto_increment,
  `entryuuid` varchar(64) not null,
  `association_type` varchar(32) not null,
  `source_association` int(11),
  `sourceuuid_documententry` varchar(64),
  `sourceuuid_folder` varchar(64),
  `sourceuuid_submissionset` varchar(64),
  `target_association` int(11),
  `targetuuid_documententry` varchar(64),
  `targetuuid_folder` varchar(64),
  `targetuuid_submissionset` varchar(64),
  `associationcontentid` int(11) not null unique,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,
  `migration_pid` int(11) not null default 0,

  constraint association_pk primary key (id),

  constraint association_fk_source_association foreign key (source_association) references associations(id),
  constraint association_fk_source_documententry foreign key (sourceuuid_documententry) references documententries(entryuuid),
  constraint association_fk_source_folder foreign key (sourceuuid_folder) references folders(entryuuid),
  constraint association_fk_source_submissionset foreign key (sourceuuid_submissionset) references submissionsets(entryuuid),
  constraint association_fk_target_association foreign key (target_association) references associations(id),
  constraint association_fk_target_documententry foreign key (targetuuid_documententry) references documententries(entryuuid),
  constraint association_fk_target_folder foreign key (targetuuid_folder) references folders(entryuuid),
  constraint association_fk_target_submissionset foreign key (targetuuid_submissionset) references submissionsets(entryuuid),

  constraint association_fk_content foreign key (associationcontentid) references associationcontent(id) on delete cascade
);

--
-- Table and index structure for table `documententry_author`
--
create table if not exists `documententry_author` (
  `id` int(11) not null auto_increment,
  `documententry_entryuuid` varchar(64) not null,
  `family_name` varchar(64) not null,
  `given_name` varchar(64),
  `further_given_names` varchar(64),
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,

  constraint documententry_author_pk primary key (id),

  constraint documententry_author_documententry_fk foreign key (documententry_entryuuid) references documententries(entryuuid) on delete cascade
);

create unique index if not exists `documententry_author_documententry_entryuuid_id`
on documententry_author(documententry_entryuuid, id);

--
-- Table and index structure for table `documententry_eventcode`
--
create table if not exists `documententry_eventcode` (
  `id` int(11) not null auto_increment,
  `documententry_entryuuid` varchar(64) not null,
  `code_name` varchar(64) not null,
  `scheme_name` varchar(64) not null,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,

  constraint documententry_eventcode_pk primary key (id),

  constraint documententry_eventcode_documententry_fk foreign key (documententry_entryuuid) references documententries(entryuuid) on delete cascade
);

create unique index if not exists `documententry_eventcode_documententry_entryuuid_id`
on documententry_eventcode(documententry_entryuuid, id);

--
-- Table and index structure for table `documententry_confidentialitycode`
--
create table if not exists `documententry_confidentialitycode` (
  `id` int(11) not null auto_increment,
  `documententry_entryuuid` varchar(64) not null,
  `code_name` varchar(64) not null,
  `scheme_name` varchar(64) not null,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,

  constraint documententry_confidentialitycode_pk primary key (id),

  constraint documententry_confidentialitycode_documententry_fk foreign key (documententry_entryuuid) references documententries(entryuuid) on delete cascade
);

create unique index if not exists `documententry_confidentialitycode_documententry_entryuuid_id`
on documententry_confidentialitycode(documententry_entryuuid, id);


--
-- Table and index structure for table `documententry_referenceid`
--
create table if not exists `documententry_referenceid` (
  `id` int(11) not null auto_increment,
  `documententry_entryuuid` varchar(64) not null,
  `reference_id` varchar(64) not null,
  `assigningauthority_id` varchar(64),
  `assigningauthority_type` varchar(64),
  `typecode` varchar(64) not null,
  `homecommunityid_id` varchar(64),
  `homecommunityid_type` varchar(64),
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,

  constraint documententry_referenceid_pk primary key (id),

  constraint documententry_referenceid_documententry_fk foreign key (documententry_entryuuid) references documententries(entryuuid) on delete cascade
);

create unique index if not exists `documententry_referenceid_documententry_entryuuid_id`
on documententry_referenceid(documententry_entryuuid, id);


alter table documententries modify column uniqueid varchar(128) not null;
alter table folders modify column uniqueid varchar(128) not null;
alter table submissionsets modify column uniqueid varchar(128) not null;

CREATE INDEX documententries_patientid_idx ON documententries (patientid, patientid_assigningauthorityid, patientid_assigningauthoritytype, id);
CREATE INDEX documententries_uniqueid_idx ON documententries (uniqueid, id);
CREATE INDEX documententries_entryuuid_idx ON documententries (entryuuid, id);
CREATE INDEX submissionsets_patientid_idx ON submissionsets (patientid, patientid_assigningauthorityid, patientid_assigningauthoritytype, id);
CREATE INDEX submissionsets_uniqueid_idx ON submissionsets (uniqueid, id);
CREATE INDEX submissionsets_entryuuid_idx ON submissionsets (entryuuid, id);
CREATE INDEX associations_entryuuid_idx ON associations (entryuuid, id);
CREATE INDEX folders_patientid_idx ON folders (patientid, patientid_assigningauthorityid, patientid_assigningauthoritytype, id);
CREATE INDEX folders_uniqueid_idx ON folders (uniqueid, id);
CREATE INDEX folders_entryuuid_idx ON folders (entryuuid, id);


alter table `documententries` add column `creationtime_upper` datetime(6);
alter table `documententries` add column `servicestarttime_upper` datetime(6);
alter table `documententries` add column `servicestoptime_upper` datetime(6);

CREATE INDEX IF NOT EXISTS documententries_logicaluuid_idx ON documententries (logicaluuid);

ALTER table documententries MODIFY practicesettingcode_codename varchar(64) null;
ALTER table documententries MODIFY practicesettingcode_schemename varchar(64) null;


CREATE INDEX IF NOT EXISTS documententries_patientid_availabilitystatus_idx ON documententries (patientid, patientid_assigningauthorityid, patientid_assigningauthoritytype, availabilitystatus, id);

create table if not exists `deleted_documententries` (
  `id` int(11) not null auto_increment,
  `entryuuid` varchar(64) not null,
  `uniqueid` varchar(64) not null,
  `deletion_status` varchar(64) not null,
  `deletion_attempts` int(11) not null,
  `creation_time` datetime(6) default current_timestamp,
  constraint deleted_documententries_pk primary key (id)
);

create index if not exists deleted_documententries_status_attempts on deleted_documententries (deletion_status, deletion_attempts);

-- Used by the XDSCleanup service for selecting documententries to delete.
create index if not exists documententries_servicestarttime_creation_time on documententries (servicestarttime, creation_time);


