
create table if not exists `fieldmigrationstatus` (
  `id` int(11) not null auto_increment,
  `migrationid` varchar(64) not null,
  `progressid` int(11) not null,
  `targetid` int(11) not null,
  `migration_start_time` datetime(6),
  `migration_end_time` datetime(6),
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,
  constraint fieldmigrationstatus_pk primary key (id)
);



ALTER TABLE documententries
ADD repository_uniqueid varchar(64);

-- sæt targetid til den med nyeste dato fra documententries
insert ignore into fieldmigrationstatus (migrationid, progressid, targetid)
values ('documententry-repositoryid-add', 0,
IFNULL(
(SELECT id FROM documententries d1
INNER JOIN  (SELECT MAX(creation_time) AS MAXDATE FROM documententries) d2
ON d1.creation_time = d2.MAXDATE
order by id desc
limit 1), 0)
);


CREATE TABLE IF NOT EXISTS `documententries_status90_deletion` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `status90_deletion_date` datetime(6) NOT NULL,
  `deletion_count` int(11) NOT NULL,
  `creation_time` datetime(6) default current_timestamp,
  `last_update_time` datetime(6) default current_timestamp on update current_timestamp,
  PRIMARY KEY (`id`)
);

insert ignore into documententries_status90_deletion (status90_deletion_date, deletion_count) values ('2002-01-01', -1);

-- SDS-6135
create index if not exists deleted_documententries_entryUuid on deleted_documententries (entryUuid);


-- SDS-6783

create table if not exists notification_configuration (
  id int(11) not null auto_increment,

  classcode_codename varchar(64) not null,
  classcode_schemename varchar(64) not null,
  typecode_codename varchar(64) not null,
  typecode_schemename varchar(64) not null,
  formatcode_codename varchar(64) not null,
  formatcode_schemename varchar(64) not null,

  topic varchar(128) not null,
  notification_type varchar(128) not null,
  creation_time datetime(6) default current_timestamp,

  constraint notifiation_configuration_pk primary key (id)
);


create table if not exists unsent_notifications (
  id int(11) not null auto_increment,
  uuid varchar(64) not null,
  patient_id varchar(64) not null,
  created_date VARCHAR(50) not null,
  topic varchar(128) not null,
  notification_type varchar(128) not null,

  constraint unsent_notifications_pk primary key (id),
  index notifications_index_1 (created_date),
  unique key notifications_unique_1 (uuid)
);

