package dk.nsp.xdscleanup.sdm.dao;

import dk.nsp.xdscleanup.nxrg.dao.TestConstants;
import org.springframework.jdbc.core.namedparam.MapSqlParameterSource;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;

import javax.sql.DataSource;

public class SdmTestDataCreator {
    private NamedParameterJdbcTemplate template;

    public SdmTestDataCreator(DataSource dataSource) {
        this.template = new NamedParameterJdbcTemplate(dataSource);
    }

    public void initializeTestDatabase() {
        // Delete everything
        template.update("delete from v2_Person", new MapSqlParameterSource());

        insertPerson(TestConstants.CPR_2, "2022-06-29");
        insertPerson(TestConstants.CPR_3, "2022-06-30");
        insertPerson(TestConstants.CPR_4, "2022-07-01");
        insertPerson(TestConstants.CPR_5, "2022-07-02");
        insertPerson(TestConstants.CPR_6, "9999-01-01");
    }

    private void insertPerson(String CPR, String StatusDato) {
        MapSqlParameterSource parameters = new MapSqlParameterSource();
        parameters.addValue("CPR", CPR);
        parameters.addValue("StatusDato", StatusDato);

        template.update("insert into v2_Person (CPR, Fornavn, Efternavn, Status, StatusDato, CreatedDate, ModifiedDate, ValidFrom) values (:CPR, 'Hans', 'Hansen', '90', :StatusDato, now(), now(), '2022-06-01');", parameters);
    }

}
