package dk.nsp.xdscleanup.openxds.health;

import dk.nsp.backgroundjob.health.HealthIndication;
import dk.nsp.backgroundjob.health.HealthIndicator;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;

public class OpenXdsHealthIndicator implements HealthIndicator {
    private JdbcTemplate template;

    public OpenXdsHealthIndicator(JdbcTemplate template) {
        this.template = template;
    }

    @Override
    public HealthIndication getHealthInfo() {
        int status = 200;
        String text = "OK";

        try {
            template.queryForObject("select 1", Integer.class);
        }
        catch(DataAccessException e) {
            status = 500;
            text = "ERROR: Database connection dead.";
        }

        return new HealthIndication(status, String.format("\"repository.db\": \"%s\"", text));
    }
}
