package dk.nsp.xdscleanup.openxds;

import org.springframework.jdbc.core.namedparam.MapSqlParameterSource;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;

import javax.sql.DataSource;

import static dk.nsp.xdscleanup.openxds.TestConstants.*;

public class TestDataCreator {
    private NamedParameterJdbcTemplate template;

    public TestDataCreator(DataSource dataSource) {
        this.template = new NamedParameterJdbcTemplate(dataSource);
    }

    public void initializeTestDatabase() {
        // Delete everything
        template.update("delete from repository", new MapSqlParameterSource());

        insertDocument(DOCUMENT_UNIQUE_ID_0);
        insertDocument(DOCUMENT_UNIQUE_ID_1);
        insertDocument(DOCUMENT_UNIQUE_ID_2);
        insertDocument(DOCUMENT_UNIQUE_ID_3);
    }

    private void insertDocument(String documentUniqueId) {
        String content = String.format("<document>%s</document>", documentUniqueId);

        MapSqlParameterSource parameters = new MapSqlParameterSource();
        parameters.addValue("documentUniqueId", documentUniqueId);
        parameters.addValue("content", content.getBytes());
        parameters.addValue("contentLength", content.length());
        parameters.addValue("hash", Integer.toString(content.hashCode()));

        template.update("insert into repository(documentuniqueid, content, mimetype, documentsize, hash) values (:documentUniqueId, :content, 'text/xml', :contentLength, :hash)", parameters);
    }
}
